Subject: Re: [VRRP] RFC5798 - clarification on checksum calculation

From: [email-masked]
Date: Tue, 15 May 2012 11:41:48 +0900 (JST)

Hello list,

Has there been any progress with regard to this topic?
I know that in an implementation of VRRPv3 for IPv4 the checksum
is calculated without pseudo-header currently, but I believe that
pseudo-header should be involved in the calculation as same as
IPv6 case.

Regards,
-- 
Tomohiko Kurahashi <[email-masked]>

From: [email-masked]
Date: Mon Apr 02 2012 20:41:51 JST
>
> Forwarded.
> Any other VRRPv3/IPv4 implementation?
> 
> 
> Thanks,
> Tomoyuki
> 
> 
> Date: Mon, 2 Apr 2012 03:26:15 +0200
> Subject: Re: [VRRP] RFC5798 - clarification on checksum calculation
> From: Hermin Anggawijaya <[email-masked]>
> To: Tomoyuki Sahara <[email-masked]>
> 
> Sahara-san
> 
> Thanks for your input.
> 
> Anyone else with either/other interpretation of the clause ?
> 
> 
> Thanks
> 
> On Mon, Apr 2, 2012 at 1:48 AM, Tomoyuki Sahara <[email-masked]> wrote:
> > Hi,
> > 
> > On Thu, Mar 29, 2012 at 4:29 PM, Hermin Anggawijaya
> > <[email-masked]> wrote:
> >> Would someone be able to help clarifying RFC5798 Sec. 5.2.8 on
> >> checksum for me please...
> >> 
> >> It says that
> >> 
> >>  "The checksum is the 16-bit one's complement of the one's complement
> >>   sum of the entire VRRP message starting with the version field and a
> >>   "pseudo-header" as defined in Section 8.1 of [RFC2460].  The next
> >>   header field in the "pseudo-header" should be set to 112 (decimal)
> >>   for VRRP.  For computing the checksum, the checksum field is set to
> >>   zero.  See RFC1071 for more detail [RFC1071]."
> >> 
> >> My interpretation of the above clause is, for IPv4 VRRP the checksum would be
> >> defined as:
> >> 
> >> "The checksum is the 16-bit one's complement of the one's complement
> >>  sum of the entire VRRP message starting with the version field"
> >> 
> >> as per RFC 3768, instead of involving "pseudo header" (as defined in
> >> Section 8.1 of [RFC2460]).
> > 
> > My understanding is only reference text ("as defined in Section 8.1 of
> > [RFC2460]") is irrelevant for IPv4.  Our implementation calculates checksum
> > including pseudo header as for TCP/UDP/DCCP.
> > 
> >> If my interpretation is correct, would it be useful to change the text to
> >> reflect specific checksum detail for IPv4 ?
> > 
> > My interpretation is different from yours but clarification should be
> > very useful.
> > It's vital for interoperable implementations of VRRPv3/IPv4.
> > 
> > 
> > Thanks,
> > Tomoyuki

---

From: Hermin Anggawijaya <[email-masked]>
Date: Wed, 16 May 2012 09:17:25 +1200

Hello

I am thinking of submitting an errata for RFC 5798 Sec. 5.2.8 to make
it more precise in describing the checksum calculation for each address family.

But reading a few responses here, I gathered that there is no general
agreement as to the original intention of the text,
I believe that for IPv4, the checksum is calculated without
pseudo-header so that it is backward compatible with RFC 3768.

Any other opinions - particularly from original authors ?

Kind Regards

Hermin Anggawijaya

On Tue, May 15, 2012 at 2:41 PM,  <[email-masked]> wrote:
> _______________________________________________
> vrrp mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/vrrp

---

From: "Nair, Anoop Govindan" <[email-masked]>
Date: Thu, 17 May 2012 05:13:21 +0100

My interpretation of the specification is that for IPv4 checksum is calculated without pseudo-header.

It would be nice if RFC authors can clarify.

Regards,

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On Behalf Of Hermin Anggawijaya
Sent: Wednesday, May 16, 2012 2:47 AM
To: [email-masked]
Subject: [VRRP] Fwd: RFC5798 - clarification on checksum calculation

Hello

Kind Regards

Hermin Anggawijaya